// Kinetophone_model.cpp
//
// Copyright 2011-2012 Roan Trail, Inc.
//
// This file is part of Kinetophone.
//
// Kinetophone is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published
// by the Free Software Foundation, either version 2 of the License,
// or (at your option) any later version.
//
// Kinetophone is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.  You should have received
// a copy of the GNU General Public License along with Kinetophone. If
// not, see <http://www.gnu.org/licenses/>.

#include "Kinetophone_model.hpp"
#include "Sound_recorder.hpp"
#include "error/Error.hpp"

using Roan_trail::Recorder::Sound_recorder;
using namespace Roan_trail::Kinetophone;

//
// Constructor/destructor/copy
//

Kinetophone_model::Kinetophone_model()
  : m_sound_recorder(new Sound_recorder)
{
  postcondition(mf_invariant(false));
}

Kinetophone_model::~Kinetophone_model()
{
  precondition(mf_invariant(false));

  delete m_sound_recorder;
}

//
// Mutators
//

void Kinetophone_model::clear()
{
  precondition(mf_invariant());

  m_sound_recorder->reset_input_overflow_count();
  m_sound_recorder->reset_output_overflow_count();

  postcondition(mf_invariant());
}

//
// Protected member functions
//

bool Kinetophone_model::mf_invariant(bool check_base_class) const
{
  static_cast<void>(check_base_class); // avoid unused warning

  bool return_value = false;

  // object allocation checking
  if (!m_sound_recorder)
  {
    goto exit_point;
  }

  return_value = true;

 exit_point:

  return return_value;
}
